4Suite™ API Documentation

# ► Module Ft.Xml.MarkupWriter

MarkupWriter provides a very friendly interface for generating XML content
Copyright 2005 Fourthought, Inc. (USA).
Detailed license and copyright information: http://4suite.org/COPYRIGHT
Project home, documentation, distributions: http://4suite.org/

Classes: MarkupWriter |  |  |  | Fields: EMPTY_NAMESPACE, EMPTY_PREFIX, XMLNS_NAMESPACE, XML_NAMESPACE

## Classes

class MarkupWriter(__builtin__.object)
General-purpose utility class for generating XML (may eventually be expanded to produce more output types)
Sample usage:
from Ft.Xml import MarkupWriter
writer = MarkupWriter(indent=u"yes")
writer.startDocument()
writer.startElement(u'xsa')
writer.startElement(u'vendor')
#Element with simple text (#PCDATA) content
writer.simpleElement(u'name', content=u'Centigrade systems')
#Note writer.text(content) still works
writer.simpleElement(u'email', content=u"info@centigrade.bogus")
writer.endElement(u'vendor')
#Element with an attribute
writer.startElement(u'product', attributes={u'id': u"100\u00B0"})
#Note writer.attribute(name, value, namespace=None) still works
writer.simpleElement(u'name', content=u"100\u00B0 Server")
#XML fragment
writer.xmlFragment('<version>1.0</version><last-release>20030401</last-release>')
#Empty element
writer.simpleElement(u'changes')
writer.endElement(u'product')
writer.endElement(u'xsa')
writer.endDocument()
Note on the difference between 4Suite writers and printers
Writer - module that exposes a broad public API for building output
bit by bit
Printer - module that simply takes a DOM and creates output from it
as a whole, within one API invokation

### Methods

__getattr__(self, value)
__init__(self, stream=<open file '<stdout>', mode 'w' at 0x345198>, **wargs)
Convenience factory function for Markup writers (based on xsl:output in XSLT)
simpleElement(self, tagName, namespace=None, extraNss=None, attributes=None, content=u'')
Create a simple tag with optional attributes and content. The complete element, start tag, optional text content, end tag, will all be generated by this one call. Must *not* be matched with an endElement call
tagName - qualified name of the element (must be unicode)
namespace - optional namespace URI
attribute - optional dictionary mapping name to unicode value
the name can either be a unicode QName or a tuple
of (QName, namespace URI)
content - optional unicode object with the text body of the
simple element
startElement(self, tagName, namespace=None, extraNss=None, attributes=None)
Create a start tag with optional attributes. Must eventually be matched with an endElement call
tagName - qualified name of the element (must be unicode)
namespace - optional namespace URI
attribute - optional dictionary mapping name to unicode value
the name can either be a unicode QName or a tuple
of (QName, namespace URI)
xmlFragment(self, fragment)
Incorporate a well-formed general entity into the output. fragment of fragment - string (must not be a Unicode object) to be incorporated verbatim into the output, after testing for wellp-formedness

### Methods inherited from class __builtin__.object

__delattr__, __getattribute__, __hash__, __new__, __reduce__, __reduce_ex__, __repr__, __setattr__, __str__

### Fields

__dict__ = <attribute '__dict__' of 'MarkupWriter' objects>
dictionary for instance variables (if defined)
__weakref__ = <attribute '__weakref__' of 'MarkupWriter' objects>
list of weak references to the object (if defined)

### Fields

EMPTY_NAMESPACE = None
EMPTY_PREFIX = None
XMLNS_NAMESPACE = u'http://www.w3.org/2000/xmlns/'
XML_NAMESPACE = u'http://www.w3.org/XML/1998/namespace'